package ch1.sec3;

import java.util.Iterator;

public class Bag<Item> implements Iterable<Item> {
    private Item[] items;
    private int size;


    @Override
    public BagIterator iterator() {
        return new BagIterator();
    }

    public Bag() {
        items = (Item[]) new Object[4];
        size = 0;
    }

    public void add(Item item) {
        if (size >= items.length) {
            resize(size * 2);
        }
        items[size] = item;
        size += 1;
    }

    public boolean isEmpty() {
        return size == 0;
    }

    public int size() {
        return size;
    }

    public static void main(String[] args) {
        Bag<Integer> bag = new Bag<>();
        System.out.println(bag.isEmpty());
        bag.add(1);
        bag.add(2);
        bag.add(3);
        bag.add(4);
        bag.add(5);
        for (Integer i : bag) {
            System.out.println(i);
        }
        System.out.println(bag.size());
    }

    private class BagIterator implements Iterator<Item> {
        private int index;

        BagIterator() {
            index = 0;
        }

        @Override
        public boolean hasNext() {
            return index < size;
        }

        @Override
        public Item next() {
            return items[index++];
        }
    }

    private void resize(int newSize) {
        Item[] newItems = (Item[]) new Object[newSize];
        for (int i = 0; i < size; i++) {
            newItems[i] = items[i];
        }
        items = newItems;
    }
}