package ch1.sec3;

public class Evaluate {
    public static double calculate(String s) {
        Stack<String> operators = new Stack<>();
        Stack<Double> values = new Stack<>();
        int[] index = {0};
        while (index[0] < s.length()) {
            int begin = index[0];
            Status status = checkStatus(s, index);
            switch (status) {
                case VALUE:
                    Double value = Double.parseDouble(s.substring(begin, index[0]));
                    values.push(value);
                    break;
                case OPERATOR:
                    String operator = s.substring(begin, index[0]);
                    operators.push(operator);
                    break;
                case CLOSE:
                    String op = operators.pop();
                    if (op == null) {
                        break;
                    }
                    calculate(values, op);
                case IGNORE:
                    break;
            }
        }
        if (values.isEmpty()) {
            return 0;
        } else {
            return values.pop();
        }
    }

    public static void main(String[] args) {
        System.out.println(calculate("(1 + ( (  2 + 3 ) * ( 4 * 5 )  )  )"));
        System.out.println(calculate("(.1+ .3)"));
        System.out.println(calculate("((sqrt(4)))"));
    }

    private enum Status {
        OPERATOR, VALUE, IGNORE, CLOSE
    }

    private static Status checkStatus(String s, int[] index) {
        char c = s.charAt(index[0]);
        switch (c) {
            case '(':
            case ' ':
                index[0]++;
                return Status.IGNORE;
            case ')':
                index[0]++;
                return Status.CLOSE;
            case 's':
                index[0] += 3;
            case '+':
            case '-':
            case '*':
            case '/':
                index[0]++;
                return Status.OPERATOR;
            case '.':
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9':
                char num = s.charAt(++index[0]);
                while ('0' <= num && num <= '9' || num == '.') {
                    index[0]++;
                    num = s.charAt(index[0]);
                }
                return Status.VALUE;
            default:
                return Status.IGNORE;
        }
    }

    private static void calculate(Stack<Double> values, String op) {
        double result = 0.0;
        switch (op) {
            case "sqrt":
                result = Math.sqrt(values.pop());
                break;
            case "+":
                result = values.pop() + values.pop();
                break;
            case "-":
                result = values.pop() - values.pop();
                break;
            case "*":
                result = values.pop() * values.pop();
                break;
            case "/":
                result = values.pop() / values.pop();
                break;
        }
        values.push(result);
    }
}
