package ch1.sec3;

import java.util.Iterator;

public class LinkBag<Item> implements Iterable<Item> {
    private Node head;
    private Node tail;
    private int size;

    @Override
    public LinkBagIterator iterator() {
        return new LinkBagIterator();
    }

    public LinkBag() {
        head = null;
        tail = null;
        size = 0;
    }

    public void add(Item item) {
        if (isEmpty()) {
            head = new Node(item, null);
            tail = head;
        } else {
            tail.next = new Node(item, null);
            tail = tail.next;
        }
        size++;
    }

    public boolean isEmpty() {
        return size == 0;
    }

    public int size() {
        return size;
    }

    public static void main(String[] args) {
        LinkBag<Integer> linkBag = new LinkBag<>();
        System.out.println(linkBag.isEmpty());
        linkBag.add(1);
        linkBag.add(2);
        linkBag.add(9);
        for (Integer i : linkBag) {
            System.out.println(i);
        }
        System.out.println(linkBag.size());
    }

    private class Node {
        private Item value;
        private Node next;

        public Node(Item value, Node next) {
            this.value = value;
            this.next = next;
        }
    }

    private class LinkBagIterator implements Iterator<Item> {
        private Node current;

        LinkBagIterator() {
            current = head;
        }

        @Override
        public boolean hasNext() {
            return current != null;
        }

        @Override
        public Item next() {
            Item item = current.value;
            current = current.next;
            return item;
        }
    }
}