package ch1.sec3;

import org.omg.CORBA.PUBLIC_MEMBER;

import java.util.Iterator;

public class LinkStack<Item> implements Iterable<Item> {
    private Node top;
    private int size;


    @Override
    public LinkStackIterator iterator() {
        return new LinkStackIterator();
    }

    public LinkStack() {
        top = null;
        size = 0;
    }

    public void push(Item item) {
        top = new Node(item, top);
        size++;
    }

    public Item pop() {
        if (isEmpty()) {
            return null;
        }
        Item item = top.value;
        top = top.next;
        size--;
        return item;
    }

    public boolean isEmpty() {
        return size == 0;
    }

    public int size() {
        return size;
    }

    public static void main(String[] args) {
        LinkStack<Integer> linkStack = new LinkStack<>();
        System.out.println(linkStack.isEmpty());
        linkStack.push(1);
        linkStack.push(2);
        linkStack.push(3);
        for (Integer i : linkStack) {
            System.out.println(i);
        }
        System.out.println(linkStack.size());
        while (!linkStack.isEmpty()) {
            System.out.println(linkStack.pop());
        }
    }

    private class Node {
        private  Item value;
        private Node next;
        public Node(Item value, Node next) {
            this.value = value;
            this.next = next;
        }
    }

    private class LinkStackIterator implements Iterator<Item> {
        private Node current;

        public LinkStackIterator() {
            current = top;
        }

        @Override
        public boolean hasNext() {
            return current !=null;
        }

        @Override
        public Item next() {
            Item item = current.value;
            current = current.next;
            return item;
        }
    }
}
