package ch2.sec1;

import java.time.Instant;
import java.util.concurrent.ThreadLocalRandom;

public class SortCompare {
    public static long time(String alg, Double[] a) {
        long start = Instant.now().toEpochMilli();
        if (alg.equals("Insertion")) {
            Insertion.sort(a);
        }
        if (alg.equals("Selection")) {
            Selection.sort(a);
        }
        long end = Instant.now().toEpochMilli();
        return end - start;
    }

    public static double timeRandomInput(String alg, int N, int T) {
        long total = 0;
        Double[] a = new Double[N];
        for (int i = 0; i < T; i++) {
            for (int j = 0 ; j < N; j++) {
                a[j] = ThreadLocalRandom.current().nextDouble(0.0, 1.0);
            }
            total += time(alg, a);
        }
        return total/1000.0;
    }

    public static void main(String[] args) {
        int N = 1000;
        int T = 100;
        double tSelect = timeRandomInput("Selection", N, T);
        double tInsert = timeRandomInput("Insertion", N, T);
        System.out.printf("Selection: %f \n Insertion: %f\n", tSelect, tInsert);
    }
}
